// the central controller for the carrier
// all requests and release messages go to a queue and are processed here

private ["_nim", "_msg" , "_res", "_plane", "_cs", "_resources", "_resType", "_answered"];

_nim = [_this, 0, ObjNull] call BIS_fnc_param;

while {true} do {
  waitUntil {count ttt_fo_messages > 0};
  (str ttt_fo_messages) call BIS_fnc_log;
  //_plane = ttt_fo_messages call BIS_fnc_arrayShift;
  _plane = ttt_fo_messages select 0;
  // removes any duplicates as well
  ttt_fo_messages = ttt_fo_messages - [ _plane ];

  switch (_plane getVariable "ttt_fo_type") do {
    case "req": {
      _res = [_nim, _plane] call TeTeT_fnc_request;
      _cs = _plane getVariable "ttt_fo_callsign";
      _resType = _plane getVariable "ttt_fo_resType";
      _resources = _plane getVariable "ttt_fo_res";
      if (_res) then {
        [Salt, _cs, format ["permission granted for %1.", ([_resType, _resources] call TeTeT_fnc_tellingName)]] call TeTeT_fnc_radio;
        _plane setVariable ["ttt_fo_request", true];
        _plane setVariable ["ttt_fo_answered", nil];
      } else {
        _answered = _plane getVariable "ttt_fo_answered";
        if (isNil "_answered") then {
          [Salt, _cs, format ["that's a negative for %1. Stay put.", ([_resType, _resources] call TeTeT_fnc_tellingName)]] call TeTeT_fnc_radio;
          _plane setVariable ["ttt_fo_answered", true];
        };
        // _plane setVariable ["ttt_fo_request", false];
        // no longer deny the request, add it to end of queue again 
        ttt_fo_messages set [count ttt_fo_messages, _plane];
      };
    };
    case "rel": {
      [_nim, _plane] call TeTeT_fnc_release;
      _plane setVariable ["ttt_fo_request", true];
    };
  };
  // not sure if this is a good idea, should prevent thrashing while removing clock like iteration
  sleep(10 - random (count ttt_fo_messages));
};
