#include "Common.h"
#define SPEEDTAXI 3
private ["_eleObj", "_nim", "_ele", "_dir", "_pos", "_plane", "_dest", "_v"];

_nim = [_this, 0, ObjNull] call BIS_fnc_param;
_plane = [_this, 1, ObjNull] call BIS_fnc_param;
_ele = [_this, 2, "E1"] call BIS_fnc_param;

// call elevator and drive atop of it
_eleObj = [_nim, _ele] call TeTeT_fnc_findElevatorObj;

[_eleObj, 1] call TTT_fnc_elevator;
waitUntil {_eleObj animationPhase "ani_ElevBarB" < -0.9};

// drive on elevator
_dir = getDir _plane;
_pos = getPosASL _plane;
_dest = CIRCLEPOS2(_pos, _dir, -29);
_dest = [_dest select 0, _dest select 1, 7.5];
while {_plane distance _dest > 4} do {
    _v = [getPosASL _plane, _dest] call BIS_fnc_vectorFromXToY;
    _plane setVelocity [
	  (_v select 0) * SPEEDTAXI,
	  (_v select 1) * SPEEDTAXI,
	  0
    ];
    sleep 0.5;
};

[_eleObj, 0] call TTT_fnc_elevator;
waitUntil {_eleObj animationPhase "ani_ElevBarT" < 0.1};

_plane;